; 15BB
; 512b SID music
; This is a 99% cover of first seconds of 
; "Bat of Basses" of Mike 
; I like that tune that is one of my most listened sid ever. Thanks Mike!!!
; I put some effort in recreating the same instrument set. 
; There are some differences, but the result is quite similar.

  processor 6502 
 
   org 2049

  .byte $0b,$08,$e8,$03,$9e,"2061",0,0,0

  .org 2061
  
; real tune:
; voice 1:
;  PW goes from $0800 to $A030 (up/down) with step of $10. $0800 is reset at new note

; cover:
; voice 1:
;  PW goes from $07F0 to $A000 with step of $10

; no vibrato in all voices
  
  
delay =   $80        ; actual delay 
pwLo1 =   $81        ; wave low byte for voice 1
pwHi1 =   $48        ; wave high byte for voice 1
step  =   $83        ; step for wave effect 
point =   $84        ; +$85 pointer

fInd  =   $86        ; filter index  
toUseLo = $87        ; freq lo to use for voice 1 
toUseHi = $88        ; freq hi to use for voice 1
indVF   = $89        ; index for voice frequency effect

duration = $47       ; 4E, 55  duration of this note
rel_dur  = $43       ; 4A, 51  duration to reload
patt     = $44       ; 4B, 52  index to current pattern
pIndex   = $45       ; 4C, 53  pulse index
pDir     = $46       ; 4D, 54  pulse dir

RDELAY = 7        ; reload delay         

; note declaration
DUR = $80    ; duration command
  
F2  = 1 
G2  = 2
Gd2 = 3
Ad2 = 4
C4  = 5
D4  = 6
Dd4 = 7
F4  = 8
G4  = 9
Gd4 = 10

      lda  #$10
      sta  step
      
      ldx  #0                ; reset pattern 
      stx  patt
      stx  patt+7
      stx  patt+14
      inx
      stx  delay             ; initial delay to virtually 0
      stx  duration
      stx  duration+7
      inx                    ; voice 3 start after the others
      inx
      stx  duration+14
      
      lda  #$1F              
      sta  $D418             ; volume max, low filter
      
      lda  #$F1
      sta  $D417             ; max resonance, filter voice 1
      
      sei
      lda  #<irq
      sta  $0314
      lda  #>irq 
      sta  $0315             
      cli      
      rts


freqLo:
  .byte 207       ; F2
  .byte 133       ; G2
  .byte 232       ; G#2 
  .byte 193       ; A#2
  .byte 103       ; C4
  .byte 137       ; D4  
  .byte 178       ; D#4
  .byte 59        ; F4 
  .byte 20        ; G4  
  .byte 160       ; G#4
  
freqHi:
  .byte 5         ; F2
  .byte 6         ; G2
  .byte 6         ; G#2
  .byte 7         ; A#2
  .byte 17        ; C4
  .byte 19        ; D4   
  .byte 20        ; D#4 
  .byte 23        ; F4
  .byte 26        ; G4
  .byte 27        ; G#4
  
FT_DIM = $10
  
filter:  
  ;.byte $30 
  .byte $35, $3A, $3F, $44, $3F, $3A, $35
  .byte $30, $2B, $26, $21, $1C, $17, $12, $0D
  .byte $08, $03
  
pwLo:
  .byte $F0, $30, $70, $B0, $F0, $30
pwHi: 
  .byte $0F, $00, $00, $00, $00, $01
  
patLo:  .byte #<(pat01-1)
patHi:  .byte #>(pat01-1)
AD:     .byte $02
SR:     .byte $91      
ctrl:   .byte $41
; ctrl2:  .byte $40
PWL:    .byte $00 
PWH:    .byte $08  

  .byte #<(pat02-1)
  .byte #>(pat02-1)
  .byte $09
  .byte $38
  .byte $51
  ; .byte $50  
  .byte $F0
  .byte $0F  
    
  .byte #<(pat03-1)
  .byte #>(pat03-1)
  .byte $09
  .byte $38
  .byte $51  
  ; .byte $50
  .byte $F0
  .byte $0F
      
; pattern
pat01:
  .byte DUR+14, Gd2, DUR+1, G2, F2, DUR+16, G2, DUR+11, Gd2, DUR+3, Ad2, DUR+1, Gd2, G2, DUR+14, F2, DUR+1, G2, F2, 0
  
pat02: 
  .byte DUR+2
  .byte Gd4, C4, Dd4, Gd4
  .byte Gd4, C4, Dd4, Gd4
  .byte G4,  C4, Dd4, G4
  .byte G4,  C4, Dd4, G4
  .byte Gd4, C4, Dd4, Gd4
  .byte Gd4, C4, Dd4, Gd4
  .byte F4,  C4, Dd4, F4
  .byte F4,  C4, Dd4, F4, 0
  
pat03:
  .byte DUR+2
  .byte Dd4, Gd4, C4, Dd4 
  .byte Dd4, Gd4, C4, Dd4 
  .byte Dd4, G4,  C4, Dd4 
  .byte Dd4, G4,  C4, Dd4 
  .byte Dd4, Gd4, C4, Dd4 
  .byte Dd4, Gd4, C4, Dd4 
  .byte Dd4, F4,  C4, Dd4 
  .byte Dd4, F4,  C4, Dd4, 0
  
 
  
irq:   
                                 ; make timbre of instruments         
timbre:                         
                                 ; make timbre of voice 1: wave                             
      lda  pwLo1
      adc  step
      sta  pwLo1
      lda  pwHi1
      adc  #0                    ; add/sub step to pulse
      sta  pwHi1
      cmp  #$07
      beq  invert
      cmp  #$0A
      bne  setPulse
invert:                          ; invert the step direction  
      lda  step
      eor  #$FF
      sec
      adc  #00
      sta  step            
      
setPulse:                        ; set pulse for voice 1  
      lda  pwLo1    
      sta  $D402
      lda  pwHi1
      sta  $D403
                                 ; make timbre of voice 1: filter
      ldy  fInd
      cpy  #FT_DIM
      beq  skipF
      iny
      sty  fInd      
skipF:                           ; read freq. from table and put to sid        
      lda  filter,y
      sta  $D416    
      
      dec  indVF                 ; dec freq effect for voice 1           
      bne  skipVF
                                 ; put the right frequency
      lda  toUseLo
      sta  $D400
      lda  toUseHi
      sta  $D401
      
skipVF:      
                                 ; make voice 2 and 3 pulse timbre       
      ldx  #7
loopV3:
      
      lda  pIndex,x
      clc
      adc  pDir,x
      sta  pIndex,x
      tay
      beq  invertD
      cmp  #6
      bne  pPulse
            
invertD:                         ; invert direction        
      lda  pDir,x       
      eor  #$FF
      sec
      adc  #00
      sta  pDir,x
      
pPulse:                           ; put pulse       
      lda  pwLo,y   
      sta  $D402,x
      lda  pwHi,y
      sta  $D403,x
      
      jsr  incVoice
      bcc  loopV3

      dec  delay      
      beq  music
      jmp  exit      
      
music:      
      lda  #RDELAY      
      sta  delay

      ldx  #$0                   ; index of first voice 
loopV:  

      ldy  duration,x
      dey
      tya
      sta  duration,x
      beq  cont1  
      jmp  nextV
      
cont1:      
      lda  patt,x                ; load pattern index of this voice 
nextIndY:      
      tay
nextInd:      
      iny                        ; increment index (so pattern must start one position before)
      tya
      sta  patt,x
                                 ; set pattern address         
      lda  patLo,x
      sta  point
      lda  patHi,x
      sta  point+1
      
      lda  (point),y             ; read current note/duration      
      beq  endPat      
      bpl  newNote
                                 ; this is a duration
      asl                        ; double the duration, but delay is half as needed
      sta  rel_dur,x             ; store duration to reload
      
      jmp  nextInd             
      
endPat:
      lda  #$00
      sta  patt,x                ; reset pattern index
      beq  nextIndY      
      
newNote:           
      tay
      
      ;lda  ctrl2,x
      lda  #00                   ; reset gate    
      sta  $D404,x
      sta  pIndex,x              ; pulse index to 0
      
      cpx  #0
      beq  specV1
                                 ; put right frequency
      lda  freqLo-1,y
      sta  $D400,x
      lda  freqHi-1,y
      sta  $D401,x     
      bne  contV      
                                 ; special action for voice 1
specV1:      
      lda  freqLo-1,y
      sta  toUseLo
      lda  freqHi-1,y
      sta  toUseHi
                                 ; double the frequency to use  
      lda  toUseLo                
      adc  toUseLo
      sta  $D400,x
      lda  toUseHi
      adc  toUseHi
      sta  $D401,x
                                 ; put initial filter cut-off frequency
      lda  #$00  
      sta  $D415
      sta  fInd          
      
      lda  #$30
      sta  $D416  
      
      lda  #2
      sta  indVF                 ; set index for voice frequency effect       
      
contV:      
      lda  rel_dur,x             ; reset duration to reload value
      sta  duration,x 
      
      lda  PWL,x
      sta  $D402,x               ; set pulse low
      lda  PWH,x
      sta  $D403,x               ; set pulse hi
      sta  pwHi1,x
      
      lda  ctrl,x
      sta  $D404,x
      lda  AD,x
      sta  $D405,x
      lda  SR,x
      sta  $D406,x
      
      lda  #1
      sta  pDir,x                ; direction up                                         
      
nextV:      
      jsr  incVoice
      bcs  exit
      jmp  loopV
exit:      
      jmp  $ea31
      
; increment voice index and test for last voice      
incVoice:
      txa
      clc
      adc  #7
      tax
      cmp  #$11
      rts      
      